<template>

  <v-dialog
    max-width="620" v-model="dialogo"
    transition="fab-transition" persistent
  >

    <v-card style="border-radius: 10px;" class="pa-6" elevation="0" outlined>

      <v-toolbar elevation="0" color="transparent" dense>

        <v-spacer />
        <v-toolbar-title class="text-h5"> {{ alumno.idAlumno > 0 ? 'Editar' : 'Nuevo' }} Alumno</v-toolbar-title>
        <v-spacer />
        <v-btn icon @click.stop="CerrarDialogo">
          <v-icon size="30"> mdi-close </v-icon>
        </v-btn>

      </v-toolbar>

      <v-card-text class="pa-4">

        <v-form ref="frmAlumno">

          <v-text-field
            name="Alumno-text" label="Nombre" v-model="alumno.nombre"
            style="border-radius: 10px;" :rules="[rules.nombre.required]"
            prepend-inner-icon="mdi-format-text" outlined
            color="white"
          />

          <v-text-field
            name="Alumno-text" label="Apellido" v-model="alumno.apellidos"
            style="border-radius: 10px;" :rules="[rules.apellido.required]"
            prepend-inner-icon="mdi-format-text" outlined
            color="white"
          />

          <v-menu
            v-model="menu"
            :close-on-content-click="false"
            :nudge-right="40"
            transition="scale-transition"
            offset-y
            min-width="auto"
          >
            <template v-slot:activator="{ on, attrs }">
              <v-text-field
                name="fecha-text" label="Fecha de Nacimiento" v-model="alumno.fechaNacimiento"
                style="border-radius: 10px;" :rules="[rules.fechaNacimiento.required]"
                prepend-inner-icon="mdi-format-text" outlined
                readonly
                v-bind="attrs"
                v-on="on"
                color="white"
              ></v-text-field>
            </template>
            <v-date-picker
              v-model="alumno.fechaNacimiento"
              @input="menu = false" locale="es"
            ></v-date-picker>
          </v-menu>

          <v-btn
            color="amber darken-2" light block style="border-radius: 10px;"
            elevation="0" x-large @click="ActualizarAlumno"
            dark v-if="alumno.idAlumno > 0"
          >
            <v-icon left dark size="25"> mdi-check </v-icon>
            Actualizar Alumno
          </v-btn>

          <v-btn
            color="blue darken-1" light block style="border-radius: 10px;"
            elevation="0" x-large @click="GuardarAlumno"
            dark v-else
          >
            <v-icon left dark size="25"> mdi-check </v-icon>
            Guardar Alumno
          </v-btn>

        </v-form>

      </v-card-text>

    </v-card>

  </v-dialog>

</template>

<script>

export default {

  props: {
    value: Boolean,
    alumno: Object
  },

  computed: {

    dialogo: {

      get(){
        return this.value
      },
      set(value){
        this.$emit('input', value)
      }

    }

  },

  data(){

    return {

      menu: false,

      rules: {

        nombre: { required: v => !!v || "El nombre es obligatorio" },

        apellido: { required: v => !!v || "El nombre es obligatorio" },

        fechaNacimiento: { required: v => !!v || "El nombre es obligatorio" }

      }

    }

  },

  methods: {

    async GuardarAlumno(){

      let config = { timeout: 5000 }

      await this.$axios.post("/alumnos", this.alumno, config).then(({data}) => {

        this.$emit("refresh");
        this.CerrarDialogo()

      })

    },

    async ActualizarAlumno(){

      let config = { timeout: 5000 }

      await this.$axios.post("/alumnos/" + this.alumno.idAlumno, this.alumno, config).then(({data}) => {

        this.$emit("refresh");
        this.CerrarDialogo()

      })

    },

    CerrarDialogo(){

      this.$emit("update:alumno", {})
      this.$refs.frmAlumno?.resetValidation()
      this.dialogo = false

    }

  }


}

</script>
